#include "graph.h"
 #include <QGradient>

#define BUFSIZE 25000
extern double bufferx[BUFSIZE];
extern double buffery[BUFSIZE];
extern double bufferx2[BUFSIZE];
extern double buffery2[BUFSIZE];

extern int SampleCount,Vmult1;
int count;
int count2;
bool F=false;
bool T=true;

Graph::Graph(QWidget *parent) :
    QWidget(parent)
{
}




Graph::~Graph()
{
    delete Widget;
    delete MyPlot;
    delete layout;
    delete d_curve;
    delete d_curve2;
    delete d_origin;
    delete grid;

}

void Graph::Attach(QWidget *Input)
{
    Widget = Input;
}

void Graph::Generate()



{



    MyPlot = new QwtPlot(NULL);

    QPalette pal = palette();
    QLinearGradient gradient;
    gradient.setCoordinateMode( QGradient::StretchToDeviceMode );
    gradient.setColorAt( 0.0, Qt::black );
    gradient.setColorAt( 0.5, Qt::blue );
    gradient.setColorAt( 1.0, Qt::black );
    pal.setBrush( QPalette::Window, QBrush( gradient ) );
    pal.setColor( QPalette::WindowText, Qt::black );
    MyPlot->setPalette(pal);

    MyPlot->setAutoReplot( F );
    MyPlot->plotLayout()->setAlignCanvasToScales( T );
    MyPlot->setAxisTitle( QwtPlot::xBottom, "Time (seconds)" );
    MyPlot->setAxisTitle(QwtPlot::yLeft, "Volts");
//    MyPlot->setAxisScale( QwtPlot::xBottom, bufferx[0], bufferx[SampleCount-1]+1.0/BUFSIZE );
//          MyPlot->setAxisScale( QwtPlot::xBottom, bufferx[0], bufferx[2048],0);
    MyPlot->setAxisScale( QwtPlot::yLeft, -5, 5,0 );

    grid = new QwtPlotGrid();
    grid->setPen( Qt::gray, 0.0, Qt::DotLine );
    grid->enableX( true );
    grid->enableXMin( true );
    grid->enableY( true );
    grid->enableYMin( false );
    grid->attach( MyPlot );

    d_origin = new QwtPlotMarker();
   d_origin->setLineStyle( QwtPlotMarker::Cross );
    d_origin->setValue( bufferx[SampleCount/2], 0 );
    d_origin->setLinePen( Qt::white, 0.0, Qt::SolidLine );
   d_origin->attach( MyPlot );

    d_curve = new QwtPlotCurve();
    d_curve->setStyle( QwtPlotCurve::Lines );
   d_curve->setPen( Qt::green );
    d_curve->setSamples(bufferx, buffery, SampleCount);
    d_curve->attach( MyPlot );

    d_curve2 = new QwtPlotCurve();
    d_curve2->setStyle( QwtPlotCurve::Lines );
    d_curve2->setPen( Qt::red );
    d_curve2->setSamples(bufferx2, buffery2, SampleCount);
    d_curve2->attach( MyPlot );

    new QwtPlotPanner( MyPlot->canvas() );
//    new QwtPlotMagnifier( MyPlot->canvas() );
    QwtPlotMagnifier *zoom_x = new QwtPlotMagnifier( MyPlot->canvas() );
    QwtPlotMagnifier *zoom_y = new QwtPlotMagnifier( MyPlot->canvas() );
    zoom_y->setWheelModifiers(Qt::ShiftModifier);
    zoom_y->setAxisEnabled(QwtPlot::xBottom,true);
    zoom_y->setAxisEnabled(QwtPlot::yLeft,false);
    zoom_x->setWheelModifiers(Qt::ControlModifier);
    zoom_x->setAxisEnabled(QwtPlot::xBottom,false);
    zoom_x->setAxisEnabled(QwtPlot::yLeft,true);


    layout = new QHBoxLayout( Widget );
    layout->addWidget(MyPlot);


    connect(&UpdateTimer, SIGNAL(timeout()), this, SLOT(Process()));
    UpdateTimer.setInterval(100);
    UpdateTimer.start();
}



void Graph::Process()
{
    d_curve->setSamples(bufferx, buffery, SampleCount);
    d_curve2->setSamples(bufferx2, buffery2, SampleCount);
    MyPlot->replot();
}

void Graph::EProcess()
{
    d_curve->setSamples(bufferx, buffery, SampleCount);
    d_curve2->setSamples(bufferx2, buffery2, SampleCount);
    MyPlot->replot();
    return;
}
void Graph::UpdateAxis()
{
//      MyPlot->setAxisScale( QwtPlot::xBottom, bufferx[0], bufferx[SampleCount-1]+1.0/BUFSIZE );
//      MyPlot->setAxisScale( QwtPlot::xBottom, bufferx[0], bufferx[511]);
    d_origin->setValue( bufferx[SampleCount/2], 0.0 );

    delete d_curve;
    delete d_curve2;

    d_curve = new QwtPlotCurve();
    d_curve->setStyle( QwtPlotCurve::Lines );
    d_curve->setPen( Qt::green );
    d_curve->setSamples(bufferx, buffery, SampleCount);
    d_curve->attach( MyPlot );

    d_curve2 = new QwtPlotCurve();
    d_curve2->setStyle( QwtPlotCurve::Lines );
    d_curve2->setPen( Qt::red );
    d_curve2->setSamples(bufferx2, buffery2, SampleCount);
    d_curve2->attach( MyPlot );

    MyPlot->replot();

}

void Graph::PauseResume(bool running)
{
  if (!running)
        UpdateTimer.stop();
    else
        UpdateTimer.start();

}
