#ifndef GRAPH_H
#define GRAPH_H

#include <QObject>
#include <QTimer>
#include <QWidget>
#include <qwt_plot.h>
#include <qwt_plot_grid.h>
#include <qwt_plot_layout.h>
#include <qwt_plot_canvas.h>
#include <qwt_plot_marker.h>
#include <qwt_plot_curve.h>
#include <qwt_plot_directpainter.h>
#include <qwt_curve_fitter.h>
#include <qwt_painter.h>
#include <qevent.h>
#include <qlayout.h>
#include <qwt_plot_magnifier.h>
#include <qwt_plot_panner.h>




class Graph : public QWidget
{
    Q_OBJECT
//    Q_WIDGET
public:
    explicit Graph(QWidget *parent = 0);
    ~Graph();
    void Attach(QWidget *Input);
    void Generate();
    void UpdateAxis();
    void PauseResume(bool running);
    void EProcess();

public Q_SLOTS:
    void Process();

private:
    QWidget *Widget;
    QwtPlot *MyPlot;
    QHBoxLayout *layout;
    QwtPlotCurve *d_curve;
    QwtPlotCurve *d_curve2;
    QwtPlotMarker *d_origin;
    QwtPlotGrid *grid;
    QTimer UpdateTimer;

};

#endif // GRAPH_H
