#include "mainwindow.h"
#include "ui_scope2.h"
#include <stdio.h>
#include <libusb.h>
#include "scope_render.h"
#include "scope_usb.h"
#include "graph.h"



#define BUF_SIZE 0x20000
#define BUF_MASK 0x1ffff
#define BUF_TO_640 (BUF_SIZE/640)

#define BUFSIZE 65536
double bufferx[BUFSIZE];
double buffery[BUFSIZE];
double bufferx2[BUFSIZE];
double buffery2[BUFSIZE];
double timmy;
double LUT1[256],LUT2[256];
double Vmult1,Vmult2,Vint1,Vint2,DeltaT;

int loop,inner_loop,loop2,SampleCount,initial_offset,indx,repeat=1;
int gain_a=4,gain_b=4, clock_mode=2,ch1_acdc=1,ch2_acdc=1,return_value;
// struct libusb_device_handle *scope_handle;
    unsigned char scope_data[BUF_SIZE];

//the LUT (look up table) is intended to correct for a number of factors
    // non linearity in the front end
    // Yaxis offset
    // Yaxis fine gain



bool ch2_enabled;

void acquire();







class scope_frame;
scope_frame *frame = NULL;











class scope_app
{
public:
    bool OnInit();
    void scope_on_idle();
    int  scope_on_exit();
//    void scope_on_idle(wxIdleEvent& evt);
};
class scope_frame
{
public:
    scope_frame();
    ~scope_frame();

//    wxGLCanvas* glPane;
//    wxMenuBar*  menuBar;
//    wxMenu*   50  fileMenu;
//    wxComboBox* comb_speed;
//    wxRadioBox* rb_ch1_acdc;
//    wxRadioBox* rb_ch2_acdc;
//    wxComboBox* comb_ch1_scale;
//    wxComboBox* comb_ch2_scale;
//    wxButton*   button_reconnect;
//    wxButton*   button_send_go;
//    void scope_on_about(wxCommandEvent& event);
//    void scope_on_exit(wxCommandEvent& event);
//    void scope_on_combo(wxCommandEvent& event);
//    void scope_on_button_connect(wxCommandEvent& event);
//    void scope_on_button_go(wxCommandEvent& event);

//    DECLARE_EVENT_TABLE()
};



MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)


{













    ui->setupUi(this);

    scope_usb(*scope_handle);
    scope_render();
    return_value=((scope_usb*)NULL)->init_usb();
printf("return code from get scope was %d",scope_handle);
//((scope_usb*)NULL)->usb_get_scope();

// ((scope_render*)NULL)-> scope_init();
//    connect(on_pushButton_clicked, SIGNAL(clicked), this, SLOT(scope_render::scope_capture_mode(*clock_mode, *ch1_acdc, *ch2_acdc, *gain_a, *gain_b)));

 // scope_render->scope_init();


OutputGraph = new Graph();
OutputGraph->Attach(ui->widget);
OutputGraph->Generate();




}

MainWindow::~MainWindow()
{
    delete ui;
}

// here are the set of gui actions

void MainWindow::on_Ch1Knob_valueChanged(int gain)
{
gain_a=gain;
    //  this code needs to translate a change on the knob into a call to hardware to change channel A gain
    printf ("CH1 gain knob value %d \n",gain_a);
}


void MainWindow::on_Ch2Knob_valueChanged(int gain)
{
gain_b=gain;
    //   this code should essentially do exactly the same thing as :on_Ch1Knob_valueChanged(int value)
    printf ("CH1 gain combo box value %d \n",gain_b);
}

void MainWindow::on_flashknob_valueChanged(int clock)
{
clock_mode=clock;
    //   this code should essentially do exactly the same thing as :on_Ch1Knob_valueChanged(int value)
    printf ("flashknob value %d \n",clock_mode);

}

void MainWindow::on_AC1_clicked()
{
ch1_acdc =1;
}

void MainWindow::on_DC1_clicked()
{
ch1_acdc =0;
}


void MainWindow::on_AC2_clicked()
{
ch2_acdc =1;
}

void MainWindow::on_DC2_clicked()
{
ch2_acdc =0;
}

void MainWindow::on_pushButton_clicked()
{

      ((scope_render*)NULL)->scope_capture_mode(clock_mode, ch1_acdc, ch2_acdc, gain_a, gain_b);
    for (loop2=0;loop2<repeat;loop2++)
    {


                printf("loop2 %d ",loop2);
acquire();
    }
}


void MainWindow::on_repeat_dial_valueChanged(int value)
{
    repeat=value;
}






void scope_app::scope_on_idle()
{
//    scope.render();
//    evt.RequestMore();
}
bool scope_app::OnInit()
{

//    scope.scope_init();
//    frame = new scope_frame();
//    SetTopWindow(frame);
//    Connect(wxID_ANY, wxEVT_IDLE, wxIdleEventHandler(scope_app::scope_on_idle));
    return true;
}
int  scope_app::scope_on_exit()
{
    return 0;
}
void acquire()
{
int r,w,resync;

//printf("repeat %d ",repeat);
//for (loop2=0;loop2<repeat;loop2++)
//{
//    printf("loop %d ",loop2);

    ((scope_usb*)NULL)->scope_request(0x33, 0x00);   // "go" code
w = 0;
resync = 0;

// check FIFO status:
while ((w != 0x2c) && (w != 0x21))
{
w = ((scope_usb*)NULL)->scope_request(0x50, 0);
resync++;
if (resync>1000) break;
}
while (w != 0x21)
{
w = ((scope_usb*)NULL)->scope_request(0x50, 0);
resync++;
if (resync>2000) break;
}
if (w == 0x21) // fifo full
{
r = ((scope_usb*)NULL)->scope_get_buffer(scope_data, sizeof(scope_data));
}
 ((scope_usb*)NULL)->scope_request(0x34, 0xff);   // "stop" code
// ((scope_usb*)NULL)->scope_request(0xD0, 0xff);  // FIFO flush, I think, these lines lock up the DDS140
// ((scope_usb*)NULL)->scope_request(0xD1, 0xff);  // FIFO enable, I think

// Set up the LUT tables. Ultimately these should translate ADC to volts, apply supplementary gain, apply offset and correct for non linearity errors
// For now, all they are going to do is calculate voltage from reading
switch (gain_a)
{
case 4: // Ch2 5v range  (bbb=000)
    Vmult1=5.0;
    break;
case 3: // Ch2 2.5v range  (bbb=001)
    Vmult1=2.5;
    break;
case 2: // Ch2 2000mv range  (bbb=100)
    Vmult1=2.0;
    break;
case 1: // Ch2 1000mv range (bbb=101)
    Vmult1=1.0;
    break;
case 0: //  Ch2 500mv range (bbb=110)
    Vmult1=0.50;
    break;
}
switch (gain_b)
{
case 4: // Ch2 5v range  (bbb=000)
    Vmult2=5.0;
    break;
case 3: // Ch2 2.5v range  (bbb=001)
    Vmult2=2.5;
    break;
case 2: // Ch2 2000mv range  (bbb=100)
    Vmult2=2.0;
    break;
case 1: // Ch2 1000mv range (bbb=101)
    Vmult2=1.0;
    break;
case 0: //  Ch2 500mv range (bbb=110)
    Vmult2=0.50;
    break;
}
switch (clock_mode)
{
case 5: //
    DeltaT=1.0/160000000;
    break;
case 4: //
    DeltaT=1.0/80000000;
    break;
case 3: //
    DeltaT=16.0/160000000;
    break;
case 2: //
    DeltaT=256.0/160000000;
    break;
case 1: //
    DeltaT=4096.0/160000000;
    break;
case 0: //
    DeltaT=1.0/480000;
    break;
}


for (loop=0; loop<256;loop++)
{
//Vint1=float(loop-(1-ch1_acdc)*127)*Vmult1/256.0;
Vint1=float(loop)*Vmult1/256.0-0.5*Vmult1*ch1_acdc;
Vint2=float(loop)*Vmult2/256.0-0.5*Vmult2*ch2_acdc;
LUT1[loop]=Vint1;
LUT2[loop]=Vint2;
}
// printf("step voltages %f,%f \n",LUT1[255],LUT2[255]);
initial_offset= 16;

for (loop=initial_offset; loop < (r/2)-1; loop++)
{
indx=loop-initial_offset;
buffery[indx]=LUT1[scope_data[2*loop]];
buffery2[indx]=LUT2[scope_data[1+(2*loop)]];
bufferx2[indx]=bufferx[indx]=float(indx)*DeltaT;
}

// printf("buffery2 voltages %f,%f \n",buffery2[255],buffery2[1255]);

SampleCount=r/2-1-initial_offset;

//    printf("scope_return_buffer returned with %d \n",r);
//    printf("resync cycles are %d \n",resync);





 ((scope_usb*)NULL)->scope_request(0x34, 0xff);   // "stop" code

QCoreApplication::processEvents();
}
















//void MainWindow::on_dial_valueChanged(int value)
//{

//}




//void MainWindow::on_dial_sliderMoved(int position)
//{

//}

//void MainWindow::on_repeat_dial_sliderMoved(int position)
//{

//}
