#include "scope_render.h"
#include "scope_usb.h"

scope_render::scope_render(QObject *parent) :
    QObject(parent)

//{

//scope_render::scope_render();
{
    return;
}




  int  scope_render::scope_acquire()

{
  extern bool ch2_enabled;
      int w,resync;
      w = 0;
      resync = 0;
      ((scope_usb*)NULL)->scope_request(0x33, 0x00);   // "go" code
      // check FIFO status:
      while ((w != 0x2c) && (w != 0x21))
      {
          w = ((scope_usb*)NULL)->scope_request(0x50, 0);
          resync++;
          if (resync>1000) break;
      }
      while (w != 0x21)
      {
          w = ((scope_usb*)NULL)->scope_request(0x50, 0);
          resync++;
          if (resync>2000) break;
      }
      if (w == 0x21) // fifo full
      {
          int r = ((scope_usb*)NULL)->scope_get_buffer(scope_data, sizeof(scope_data));
          if (r < 0) return 0;
          return r;
      }
      return 0;
  }
    void scope_render::scope_capture_mode(int clock_mode, int ch1_acdc, int ch2_acdc, int gain_a, int gain_b)
    {

        printf ("in to capture_mode %d ,%d ,%d ,%d ,%d \n",clock_mode, ch1_acdc, ch2_acdc, gain_a, gain_b);

        bool ch2_enabled;
        int CH1_ACDC = 0x10;           // DC
        int CH2_ACDC = 0x10;           // DC
        if (ch1_acdc) CH1_ACDC = 0x0;  // AC
        if (ch2_acdc) CH2_ACDC = 0x0;  // AC



        //  Command  Bit Field ..... Description
        //    0x22   0000 0aa0
        //                 00  ..... Gain Ch1   (0x0) port B
        //                 01  ..... Gain Ch1   (0x2)
        //                 10  ..... Gain Ch1   (0x4)
        //    0x23   0b00 0000
        //            0        ..... Gain Ch2   (0x00) port E
        //            1        ..... Gain Ch2   (0x40)
        //    0x24   000c abbr
        //                   0 ..... Relay
        //                   1 ..... Relay - Ch1 to (Ch1 & Ch2) ADC
        //                 00  ..... Gain Ch2   (| 0x0)
        //                 01  ..... Gain Ch2   (| 0x2)
        //                 10  ..... Gain Ch2   (| 0x4)
        //                 11  ..... Gain Ch2   (| 0x6)
        //                0    ..... Gain Ch1   (| 0x0)
        //                1    ..... Gain Ch1   (| 0x8)
        //              0      ..... Ch2 AC     (| 0x00)
        //              1      ..... Ch2 DC     (| 0x10)
        //    0x94   000d ssss
        //              0      ..... Ch1 AC
        //              1      ..... Ch1 DC
        //                0000 ..... 100Mhz  (0x0)
        //                1100 .....  10Mhz  (0xc)  80/0x8
        //                1000 ..... 625Khz  (0x8)  80/0x80
        //                1011 .....  39Khz  (0xb)  80/0x800
        //                1010 .....   ?     (0xa)

        int reg22 = 0;
        int reg23 = 0;
        int reg94_clock = 0;
        int reg24_a = 0;
        int reg24_b = 0;

        switch (gain_a)
        {
        case 4:  // Ch1 5v range  (aaa=001)
            reg22=0x00;  reg24_a = 0x08;
            break;
        case 3: // Ch1 2.5v range (aaa=011)
            reg22=0x02;  reg24_a = 0x08;
            break;
        case 2:  // Ch1 200mv range (aaa=000)
            reg22=0x00;  reg24_a = 0x00;
            break;
        case 1:  // Ch1 100mv range (aaa=010)
            reg22=0x02;  reg24_a = 0x00;
            break;
        case 0:   // Ch1 50mv range (aaa=100)
            reg22=0x04;  reg24_a = 0x00;
            break;

        //            case 4:  // Ch1 5v range  (aaa=001)
//                reg22=0x00;  reg24_a = 0x08;
//                break;
//            case 3: // Ch1 0.5v range (aaa=011)
//                reg22=0x02;  reg24_a = 0x08;
//                break;
//            case 2:  // Ch1 200mv range (aaa=000)
//                reg22=0x00;  reg24_a = 0x00;
//                break;
//            case 1:  // Ch1 100mv range (aaa=010)
//                reg22=0x02;  reg24_a = 0x00;
//                break;
//            case 0:   // Ch1 50mv range (aaa=100)
//                reg22=0x04;  reg24_a = 0x00;
//                break;
        }

        switch (gain_b)
        {
            case 4: // Ch2 5v range  (bbb=000)
                reg23=0x00; reg24_b = 0x00;
                break;
            case 3: // Ch2 0.5v range  (bbb=001)
                reg23 = 0x00; reg24_b = 0x02;
                break;
            case 2: // Ch2 200mv range  (bbb=100)
                reg23 = 0x40; reg24_b = 0x00;
                break;
            case 1: // Ch2 100mv range (bbb=101)
                reg23 = 0x40; reg24_b = 0x02;
                break;
            case 0: //  Ch2 50mv range (bbb=110)
                reg23 = 0x40;  reg24_b = 0x04;
                break;
        }

      ch2_enabled = true;
      switch (clock_mode)
      {
      case 4:
          reg94_clock = 0x0;        // 100Mhz
          break;
      case 5:
          reg24_a = 0x9;            // probe 1 to both ADCs (200 Mhz)
          reg24_b = 0;
          reg94_clock = 0x0;        // 100Mhz
          ch2_enabled = false;
          break;
      case 3:
          reg94_clock = 0xc;        // 10Mhz
          break;
      case 2:
          reg94_clock = 0x8;        // 625Khz
          break;
      case 1:
          reg94_clock = 0xb;        // 39Khz
          break;
      case 0:
          reg94_clock = 0xa;        // 240khz continuous
          break;
      case 6:
          reg94_clock = 0xd;        // ?Mhz
          break;
      default:
          reg94_clock = 0x0;        // 100Mhz
      }
      ((scope_usb*)NULL)->scope_request(0x22, reg22);
      ((scope_usb*)NULL)->scope_request(0x23, reg23);
      ((scope_usb*)NULL)->scope_request(0x24, reg24_a | reg24_b | CH2_ACDC);
      ((scope_usb*)NULL)->scope_request(0x94, reg94_clock | CH1_ACDC);
    }
  void scope_render::scope_init()
  {
      ((scope_usb*)NULL)->init_usb();

      ((scope_usb*)NULL)->scope_request(0x76, 0xe8);  // timer for square wave output?
      ((scope_usb*)NULL)->scope_request(0x77, 0x9b);  // timer
      ((scope_usb*)NULL)->scope_request(0x78, 0xe8);  // timer
      ((scope_usb*)NULL)->scope_request(0x79, 0x9b);  // timer


      ((scope_usb*)NULL)->scope_request(0x63, 0x04);
      ((scope_usb*)NULL)->scope_request(0x75, 0x00);
      ((scope_usb*)NULL)->scope_request(0x34, 0x00);  // 0=enable scope mode 1=enable logic analyzer mode

   //   usb.scope_request(0x7a, 0xfb);  // timer
   //   usb.scope_request(0x7b, 0x8c);  //
   //   usb.scope_request(0x7c, 0xff);  //
   //   usb.scope_request(0x7d, 0xc4);  //

//      scope_render::scope_capture_mode(0, 0, 0, 0, 0); // 100Mhz, 2 probes

     ((scope_usb*)NULL)->scope_request(0xe7, 0x00);
  }


